#************** IF binomial mthode premire (IF1) ****************
# Intervalle de fluctuation bilatral au seuil minimal de probabilit s
# d'une variable binomiale X de paramtres n et p et de la variable
# frquence X/n correspondante
# a est la plus petite valeur de X telle que P(X <= a) > (1 - s)/2)
# b est la plus petite valeur de X telle que P(X <= b) >= (1 - (1 - s)/2)
# [a ; b] est l'intervalle de fluctuation de X de proba. mini. s
#*******************************************************************
# VARIABILIT DES BORNES DES IF1(exacte) IFasy2 (seconde) ET
# IFasyT (terminale) DES VARIABLES FRQUENCES EN FONCTION DE p
#----------------------------
# Fonction utilitaire
IF_Bino <- function(n, p, s){
   repartX <- pbinom(0:n, n, p)
   if (max(repartX) <= (1 - s) / 2) {
   	a <- 0
   } else {
      rang_a <- min(which(repartX > (1 - s) / 2))
      a <- rang_a - 1
   }
   if (min(repartX) > (1 + s) / 2) {
       b <- n
   } else {
      rang_b <- min(which(repartX >= (1 + s) / 2))
      b <- rang_b - 1
   }   
   IF <- c(a, b)
   return(IF)
}

#----------------------------
# Cette fonction utilise IF_Bino
abak_IF <- function(n = 10, seuil = .95, nbvalp = 100, NumIF = seq(10, 40, 3)){
   subdivp <- seq(.01, .99, length = nbvalp)
   bInfIF <- NULL ; bSupIF <- NULL
   bInfIFasyT <- NULL ; bSupIFasyT <- NULL
   if (seuil == .95) {bInfIFasy2 <- NULL ; bSupIFasy2 <- NULL}
   g <- qnorm(1 - (1 - seuil) / 2)
   for (p in subdivp) {
      bInfIF <- c(bInfIF, IF_Bino(n, p, seuil)[1] / n)
      bSupIF <- c(bSupIF, IF_Bino(n, p, seuil)[2] / n)
      if (seuil == .95){
         bInfIFasy2 <- c(bInfIFasy2, max(p - 1 / sqrt(n), 0))
         bSupIFasy2 <- c(bSupIFasy2, min(p + 1 / sqrt(n), 1))
      }
      bInfIFasyT <- c(bInfIFasyT, max(p - g * sqrt(p * (1 - p) / n), 0))
      bSupIFasyT <- c(bSupIFasyT, min(p + g * sqrt(p * (1 - p) / n), 1))  
   }
   # GRAPHIQUES
      if (seuil == .95){
         minY <- min(c(bInfIF, bInfIFasy2, bInfIFasyT))
         maxY <- max(c(bSupIF, bSupIFasy2, bSupIFasyT))
      } else {
         minY <- min(c(bInfIF, bInfIFasyT))
         maxY <- max(c(bSupIF, bSupIFasyT))
      }
   plot(subdivp, bInfIF, type = "l", col = "green", ylim = c(minY, maxY), lwd = 2,
         main = paste("VARIABILIT DES IF D'UNE VARIABLE FRQUENCE",
            "\nEN FONCTION DE p ; Seuil :", seuil, "; n :", n,
            "\nTrait vert : IF1, points tirets rouges : IFasympT, tirets noirs : IFasym2"),
         xlab = "Valeur (thorique) de p dans la population",
         ylab = "Valeur des bornes des IF des frquences",
         xaxp = c(0, 1, 10), yaxp = c(0, 1, 10))
      lines(subdivp, bSupIF, col = "green", lwd = 2)
      if (seuil == .95) {
         lines(subdivp, bInfIFasy2, lty = 2, lwd = 2)
         lines(subdivp, bSupIFasy2, lty = 2, lwd = 2)
      }
      lines(subdivp, bInfIFasyT, lty = 4, col = "red", lwd = 2)
      lines(subdivp, bSupIFasyT, lty = 4, col = "red", lwd = 2)
      for (i in NumIF) {
         lines(c(subdivp[i], subdivp[i]), c(bInfIF[i], bSupIF[i]), col = "green")
      }
      abline(h = seq(0, 1, .1), v = seq(0, 1, .1), col = "grey80", lty = 2)
}

