# En important les donnes de cette manire, les variables noms et
# bouchon sont interprtes comme des facteurs.
# Dossier lyce.
(sem1 <- read.csv("D:/DocuTPHR/MathProbaStat/Proba/TP_TD/HubRayGraine2012.csv",
	sep=";", dec=","))

(sem1 <- read.csv("T:/DocuTPHR/MathProbaStat/Proba/TP_TD/Bouteilles/HubRayGraine2012.csv",
   sep=";", dec=","))

# Dossier DELL.
(sem1 <- read.csv("E:/HubW/CoursMath/CoursProba/Simulation/TPTD_Simul/HubRayGraine2012.csv",
   sep=";", dec=","))

# Les donnes.
str(sem1)

names(sem1)

#*********************************************************
# Premires explorations graphiques en boites  pattes.
# Bouchons rouges et bleus sont mis ensemble.
# Quelle est la diffrence de rsultat entre les deux commandes?
# Que font les [...]dans la commande boxplot(sem1[3:6]) ?
boxplot(sem1$A_10, sem1$B_20, sem1$C_50, sem1$D_100)

# On fait la mme chose en dsignant les colonnes 3  6 du tableau.
# L'avantage c'est que les modalits apparaitront sur les abscisses.
boxplot(sem1[3:6])

#*********************************************************
# On spare bleus et rouges dans deux tableaux diffrents.
# Que font les [...]dans ce cas ?
(sem1R <- sem1[sem1$bouchon == "rouge", ])

(sem1B <- sem1[sem1$bouchon == "bleu", ])

boxplot(sem1R[3:6])

boxplot(sem1B[3:6])

#-------------------------------------------------------
# Homognser les chelles des boites  pattes,
# mettre des noms aux axes un titre signifiant.
# On illustre graphiquement les colonnes 3  6.
# Colorer les boites en rouge et en bleu
boxplot(sem1[3:6],
        ylim = c(.1, .7),
        main = "Bouchons bleus et rouges",
        ylab = "Frquence de graines rouges dans l'chantillon",
        xlab = "Tailles d'chantillons")

boxplot(sem1R[3:6],
        ylim = c(.1, .7),
        main = "Bouchons rouges",
        ylab = "Frquence de graines rouges dans l'chantillon",
        xlab = "Tailles d'chantillons",
		  border = "red")

boxplot(sem1B[3:6],
        ylim = c(.1, .7),
        main = "Bouchons bleus",
        ylab = "Frquence de graines rouges dans l'chantillon",
        xlab = "Tailles d'chantillons",
		  border = "blue")

#*********************************************************
# Crer des nouvelles variables pour reprsenter les tailles
# d'chantillon sur une chelle graphique

# Tous les bouchons ensemble
# On cre un vecteur contenant la srie de 4 rptitions de la colonne
# des couleurs de bouchons pour les 4 colonnes A, B, C, D.
CoulBouch <- rep(sem1$bouchon, 4)

# On cre un vecteur contenant la srie des rptitions des 4 tailles
# d'chantillons pour les 4 colonnes A, B, C, D.
taillechant <- rep(c(10, 20, 50, 100), each = dim(sem1)[1])

# On peut mettre bout  bout les 4 colonnes A, B, C, D, dans un tableau.
freqAR <- c(sem1$A_10, sem1$B_20, sem1$C_50, sem1$D_100)

(sem1_1 <- data.frame(list(CoulBouch = CoulBouch,
   taillechant = taillechant, freqAR = freqAR)))

str(sem1_1)

#----------
# Les bouchons rouges
taillechantR <- rep(c(10, 20, 50, 100), each = dim(sem1R)[1])

freqAR_R <- c(sem1R$A_10, sem1R$B_20, sem1R$C_50, sem1R$D_100)

(sem1_1R <- data.frame(
   list(taillechant = taillechantR, freqAR = freqAR_R)))

#----------
# Les bouchons bleus
taillechantB <- rep(c(10, 20, 50, 100), each = dim(sem1B)[1])

freqAR_B <- c(sem1B$A_10, sem1B$B_20, sem1B$C_50, sem1B$D_100)

(sem1_1B <- data.frame(
  list(taillechant = taillechantB, freqAR = freqAR_B)))

#*********************************************************
# Exploration graphiques en nuages de points
plot(taillechant, freqAR, main = "Bouchons rouges et bleus",
     ylim = c(.1, .7),
     pch = 19, col = c("blue", "red")[sem1$bouchon])

#----------
plot(taillechantR, freqAR_R, main = "Bouchons rouges",
     ylim = c(.1, .7),
     pch = 19, col = "red")

#----------
plot(taillechantB, freqAR_B, main = "Bouchons bleus",
     ylim = c(.1, .7),
     pch = 19, col = "blue")

#-------------------------------------------------------
# On peut faire des boites  pattes avec la fonction plot(...)
# Les abscisse doivent tre un objet facteur :
plot(as.factor(taillechant), freqAR, main = "Bouchons rouges et bleus",
     ylim = c(.1, .7),
     xlab = "Taille des chantillons",
     ylab = "Frquence de graines d'AR dans l'chantillon")

#----------
plot(as.factor(taillechantR), freqAR_R, main = "Bouchons rouges",
     border = "red", ylim = c(.1, .7),
     xlab = "Taille des chantillons",
     ylab = "Frquence de graines d'AR dans l'chantillon")

#----------
plot(as.factor(taillechantB), freqAR_B, main = "Bouchons bleus",
     border = "blue", ylim = c(.1, .7),
     xlab = "Taille des chantillons",
     ylab = "Frquence de graines d'AR dans l'chantillon")

#*********************************************************
#*********************************************************
# Lorsque la taille de l'chantillon augmente (n=500, n=1000,
# n=5000) on ne peut plus faire d'exprience relle, on la remplace
# par une simulation numrique, comme cela se fait dans beaucoup d'autres
# domaines scientifiques, techniques, biologiques.
# On va crer des donnes simules que l'on stockera dans 2 variables,
# tailles d'chantillons (taillechantS), et Frquences simules de
# graines d'AR (freqAR_S). Les tailles d'chantillons simuls seront
# de 20, 50, 100, 500, 1000,5000. On fera 30 rptitions de chaque
# simulation (comme si c'tait une classe de 30 lves).

# Les paramtres des lots (NQA correspondant aux bouchons rouges)
p <- .3 ; nbsim = 30

# Cration des tailles d'chantillons
taillEch <- rep(c(20, 50, 100, 500, 1000, 2000), each = nbsim)

# Cration d'une fonction pour la Simulation de sries "binomiales"
# Elle gnre nbsim valeurs tires d'une distribution binomiale de
# paramtres taille et p.
EchBino <- function(taille){rbinom(nbsim, taille, p)}

# Simulation numrique de 6 sries d'chantillons de tailles
#  n = 20, 50, 100, 500, 1000, 2000. La variable X est le nombre de
# graine d'AR (boules rouges) dans l'chantillon
EffBino <- c(EchBino(20), EchBino(50), EchBino(100),
   EchBino(500), EchBino(1000), EchBino(2000))

# On fait le graphique (en boite) pour se rendre compte que ??
plot(as.factor(taillEch), EffBino)

# On passe donc  la variable X/n frquence de graines d'AR
# dans l'chantillon de taille n
FreqBino <- c(EchBino(20) / 20, EchBino(50) / 50, EchBino(100) / 100,
   EchBino(500) / 500, EchBino(1000) / 1000, EchBino(2000) / 2000)

# Cette fois-ci le graphique (en boite) est pertinent
plot(as.factor(taillEch), FreqBino,
   main = "Distributions* simule des frquences d'AR\npar taille d'chantillon",
   xlab = "Tailles d'chantillons",
   ylab = "Frquences* simules des graines d'AR",
   border = "red")

# On poursuit par le nuage de points
plot(taillEch, FreqBino,
   col = "red",
   main = "Distributions* simule des frquences d'AR\npar taille d'chantillon",
   xlab = "Tailles d'chantillons",
   ylab = "Frquences* simules des graines d'AR")

#-----------------------------------------
# Une version fonction pour rpter les simulations facilement
GraineSimul <- function(p = .3, nbsim = 30){
   taillEch <- rep(c(20, 50, 100, 500, 1000, 2000), each = nbsim)
   EchBino <- function(taille){rbinom(nbsim, taille, p)}
   EffBino <- c(EchBino(20), EchBino(50), EchBino(100),
   EchBino(500), EchBino(1000), EchBino(2000))
   FreqBino <- c(EchBino(20) / 20, EchBino(50) / 50, EchBino(100) / 100,
      EchBino(500) / 500, EchBino(1000) / 1000, EchBino(2000) / 2000)
   plot(as.factor(taillEch), FreqBino,
      main = "Distributions* simule des frquences d'AR\npar taille d'chantillon",
      xlab = "Tailles d'chantillons",
      ylab = "Frquences* simules des graines d'AR",
      border = "red")
# dev.new() # avec Tinn-R pour ouvrir plusieurs fentres graphiques.
   plot(taillEch, FreqBino,
      col = "red",
      main = "Distributions* simule des frquences d'AR\npar taille d'chantillon",
      xlab = "Tailles d'chantillons",
      ylab = "Frquences* simules des graines d'AR")
}

#*********************************************************
