# REPRSENTATIONS GRAPHIQUES
MoivreLap <- function(n = 100, p = .2){
   X <- 0:n
   EspX <- n * p ; XC <- X - EspX
   EcTypX <- sqrt(n * p * (1 - p)) ; XCR <- XC / EcTypX
   bornesX <- seq(-.5, n + .5, 1)
   bornesXCR <- c((XC - 1 / 2) / EcTypX, (n - EspX + 1 / 2) / EcTypX)
   DistribX <- dbinom(X, n, p)
   LhistX <- list(breaks = bornesX, counts = DistribX * n, mids = X,
              density = DistribX, equidist = TRUE, xname = NULL)
      class(LhistX) <- "histogram"
   LhistXCR <- list(breaks = bornesXCR, counts = DistribX * n, mids = XCR,
             density = DistribX * EcTypX, equidist = TRUE, xname = NULL)
      class(LhistXCR) <- "histogram"
   XGaussCR <- seq(-4, 4, length = 1000) ; YGaussCR <- dnorm(XGaussCR)
   maxY <- max(YGaussCR, DistribX)
   # Affichage des graphiques
   par(mfrow = c(3, 1))
   # Le diagramme en btons
   plot(X, DistribX, type = "h", col = "blue", lwd = 2,
         main = paste("X variable binomiale de paramtres n =", n, ", p =", p,
                      "\nDistribution de probabilit, diagramme en barres"),
         ylab = "Probabilit",
         xlab = "Variable X")
      grid()
   # L'"histogramme" de X 
   plot(LhistX, freq = FALSE, col = "blue",
         main = "Histogramme de X",
         xlab = "Classes de la forme [k-0,5 ; k+0,5[ ; 0<=k<=n",
         ylab = "Probabilit",
         ylim = c(0, max(DistribX)))
      grid()
      abline(v = seq(-.5, n + .5, 1), lty = 3)
   # L'"histogramme" de la variable centre rduite Z
   # avec densit gaussienne derrire
   plot(LhistXCR, freq = FALSE, col = "green",
         main = paste("Histogramme de Z variable centre rduite de",
            "\nX binomiale de paramtres n =", n, ", p =",p),
         xlab = paste("Classes de la forme\n[(k-EspX-0,5) / EcTypX ; (k-ExpX+0,5) / EcTypX[ ; 0<=k<=n"),
         ylab = "Densit",
         ylim = c(0, maxY),
         xlim = c(-4, 4))
      points(XGaussCR, YGaussCR, type = "l", col = "red", lwd = 2)
      abline(h = c(.1, .2, .3, .4), v = bornesXCR, lty = 3)
}

#-------------------------------------------------------------
# BINO ET GAUSS 0, 1,  SUR LE MME AXE
MoivreLap1 <- function(n = 10, p = .5){
   X <- 0:n
   EspX <- n * p ; XC <- X - EspX
   EcTypX <- sqrt(n * p * (1 - p)) ; XCR <- XC / EcTypX
   bornesX <- seq(-.5, n + .5, 1)
   bornesXCR <- c((XC - 1 / 2) / EcTypX, (n - EspX + 1 / 2) / EcTypX)
   DistribX <- dbinom(X, n, p)
   LhistXCR <- list(breaks = bornesXCR, counts = DistribX * n, mids = XCR,
      density = DistribX * EcTypX, equidist = TRUE, xname = NULL)
      class(LhistXCR) <- "histogram"
   XGaussCR <- seq(-4, 4, length = 1000) ; YGaussCR <- dnorm(XGaussCR)
   maxY <- max(YGaussCR, DistribX)
   # L'"histogramme" de X
   plot(LhistXCR, freq = FALSE, col = "grey",
         main = paste("SUPERPOSITION INCONGRUE D'UNE BINOMIALE  n =", n, ", p =", p, 
                      "\nET DE LA VARIABLE CENTRE RDUITE CORRESPONDANTE"),
         xlab = "??????",
         ylab = "??????",
         ylim = c(0, maxY), xlim = c(-4, n))
      points(XGaussCR, YGaussCR, type = "l", col = "red", lwd = 2)
   #  Le diagramme en btons
   points(X, DistribX, type = "h", col = "blue", lwd = 2)
      grid(col = "grey60")
}

#-------------------------------------------------------------
# BINO ET BINO CR  SUR LE MME AXE
MoivreLap2 <- function(n = 10, p = .5){
   X <- 0:n
   EspX <- n * p ; XC <- X - EspX
   EcTypX <- sqrt(n * p * (1 - p)) ; XCR <- XC / EcTypX
   bornesX <- seq(-.5, n + .5, 1)
   bornesXCR <- c((XC - 1 / 2) / EcTypX, (n - EspX + 1 / 2) / EcTypX)
   DistribX <- dbinom(X, n, p)
   LhistXCR <- list(breaks = bornesXCR, counts = DistribX * n, mids = XCR,
      density = DistribX * EcTypX, equidist = TRUE, xname = NULL)
      class(LhistXCR) <- "histogram"
   maxY <- max(c(DistribX, DistribX * EcTypX))
   # L'"histogramme" de X centre rduite
   plot(LhistXCR, freq = FALSE, col = "grey",
         main = paste("Distribution de X , binomiale n =", n, ", p =",p, "(barres bleues)",
            "\nDistribution de Z (X centre rduite ; barres grises)"),
         xlab = "????????",
         ylab = "DENSIT",
         ylim = c(0, maxY), xlim = c(-4, n))
   #  L'"histogramme" de X
      for (k in 1:(n + 1)) {
         polygon(c(bornesX[k], bornesX[k], bornesX[k + 1],bornesX[k + 1]),
                 c(0, DistribX[k], DistribX[k], 0),
                 col = "blue")
      }
      grid(col = "grey60")
}

#----------------------------------------------
#----------------------------------------------
# CONSTRUCTION MANUELLE DE A  Z
# X EST UNE VARIABLE ALATOIRE DE LOI BINOMIALE DE PARAMTRES n ET p
# BTONS ET RECTANGLES POUR LA DISTRIBUTION BINOMIALE
n <- 3 ; p <- 0.5
(x <- 0:n)
(distribX <- dbinom(0:n, n, p))

# LES BTONS
plot(x, distribX, type = "h", col = "blue", lwd = 5)
grid(col = "grey50")

# LES RECTANGLES UN PAR UN
   polygon(c(-0.5, -0.5, 0.5, 0.5), c(0, distribX[1], distribX[1], 0), col = "cyan")
   polygon(c(0.5, 0.5, 1.5, 1.5), c(0, distribX[2], distribX[2], 0), col = "cyan")
   polygon(c(1.5, 1.5, 2.5, 2.5), c(0, distribX[3], distribX[3], 0), col = "cyan")
   polygon(c(2.5, 2.5, 3.5, 3.5), c(0, distribX[4], distribX[4], 0), col = "cyan")

# MIEUX DFINIR LES CHELLES DE L'AXE DES ABSCISSES ET DE L'AXE DES ORDONNES
plot(x, distribX, type = "n",
     xlim = c(-.5, n + .5),
     ylim = c(0, max(distribX)))
   polygon(c(-0.5, -0.5, 0.5, 0.5), c(0, distribX[1], distribX[1], 0), col = "cyan")
   polygon(c(0.5, 0.5, 1.5, 1.5), c(0, distribX[2], distribX[2], 0), col = "cyan")
   polygon(c(1.5, 1.5, 2.5, 2.5), c(0, distribX[3], distribX[3], 0), col = "cyan")
   polygon(c(2.5, 2.5, 3.5, 3.5), c(0, distribX[4], distribX[4], 0), col = "cyan")
   points(x, distribX, type = "h", col = "blue", lwd = 5)
   grid(col = "grey50")

# ON PASSE  LA VARIABLE CENTRE RDUITE Z = (X - E(X)) / RACINE(V(X))
# ON FAIT LES RECTANGLES LES ORDONNES SONT LES DENSITS
EspX <- n * p; etypX <- sqrt(n * p * (1 - p))
(xCR <- (x - EspX) / etypX)

# LES BORNES DES CLASSES CENTRES RDUITES
(bornesX <- seq(-.5, n + .5, 1))
(BornesXCR <- (bornesX - EspX) / etypX)

# LES DENSITS
(densiteXCR <- distribX * etypX)

# ON OUVRE UNE FENTRE GRAPHIQUE DE TRAC VIDE
plot(xCR, densiteXCR, type = "n")

# ON TRACE LES RECTANGLES UN PAR UN
polygon(c(BornesXCR[1], BornesXCR[1], BornesXCR[2], BornesXCR[2]),
			c(0, densiteXCR[1], densiteXCR[1], 0), col = "grey80")
polygon(c(BornesXCR[2], BornesXCR[2], BornesXCR[3], BornesXCR[3]),
			c(0, densiteXCR[2], densiteXCR[2], 0), col = "grey80")
polygon(c(BornesXCR[3], BornesXCR[3], BornesXCR[4], BornesXCR[4]),
			c(0, densiteXCR[3], densiteXCR[3], 0), col = "grey80")
polygon(c(BornesXCR[4], BornesXCR[4], BornesXCR[5], BornesXCR[5]),
			c(0, densiteXCR[4], densiteXCR[4], 0), col = "grey80")
grid(col = "grey50")

# IL Y A  NOUVEAU DEUX PETITS PROBLME QU'ON S'EMPRESSE DE RSOUDRE
# LES CHELLES DE L'AXE DES ABSCISSES ET DE L'AXE DES ORDONNES
minX <- floor(min(BornesXCR)) ; maxX <- ceiling(max(BornesXCR))
plot(xCR, densiteXCR, type = "n",
     xlim = c(minX, maxX),
     ylim = c(0, max(distribX)))

# IL SUFFIT DE REFAIRE LES POLYGONES
# rexcuter les lignes polygon ci-dessus

# ON TRACE LES RECTANGLES AVEC UNE BOUCLE "POUR"
plot(xCR, densiteXCR, type = "n",
     xlim = c(minX, maxX),
     ylim = c(0, max(distribX)))
for (k in 1:(n + 1)) {
   polygon(c(BornesXCR[k], BornesXCR[k], BornesXCR[k + 1], BornesXCR[k + 1]),
           c(0, densiteXCR[k], densiteXCR[k], 0), col = "grey80")
}
grid(col = "grey50")

#----------------------------------------------
# IL NE RESTE PLUS QU' RASSEMBLER QUELQUES LIGNES POUR POUVOIR
# REFAIRE LA MME CHOSE POUR D'AUTRS VALEURS DE n ET p 
# AVEC QUELQUES VARIANTES ...
MoivreLap0 <- function(n = 10, p = .5){
   x <- 0:n
   distribX <- dbinom(x, n, p)
   EspX <- n * p ; etypX <- sqrt(n * p * (1 - p))
   densiteXCR <- distribX * etypX
   subdivX <- seq(-.5, n + .5, 1)
   xCR <- (x - EspX) / etypX
   subdivXCR <- (subdivX - EspX) / etypX
   # "HISTOGRAMME" DE LA DISTRIBUTION BINOMIALE DE LA VARIABLE X
   #par(mfrow = c(2, 1))
   plot(x, distribX, type = "n", xlim = c(-.5, n + .5),
         xlab = "Valeurs de la variable X",
         ylab = "Probabilits binomiales",
         main = paste("Distribution de probabilit de X binomiale n =", n, ", p =", p))
      for (k in 1:(n + 1)) {
         polygon(c(subdivX[k], subdivX[k], subdivX[k + 1], subdivX[k + 1]),
                 c(0, distribX[k], distribX[k], 0), col = "cyan")
      }
      points(x, distribX, type = "h", col = "blue", lwd = 2)
      grid()
   # "HISTOGRAMME" DE LA VARIABLE CENTRE RDUITE Z = (X - E(X)) / cartype(X)
   plot(xCR, densiteXCR, type = "n", xlim = c(-4, 4),
         xlab = "Valeurs de la variable Z",
         ylab = "Densit",
         main = paste("Distribution de probabilit de Z (X centre rduite)",
                      "\nX binomiale n =", n, ", p =", p))     
      for (k in 1:(n + 1)) {
         polygon(c(subdivXCR[k], subdivXCR[k], subdivXCR[k + 1], subdivXCR[k + 1]),
                 c(0, densiteXCR[k], densiteXCR[k], 0), col = "grey80")
      }
      xGauss <- seq(-4, 4, length = 1000) ; yGauss <- dnorm(xGauss)
      lines(xGauss, yGauss, col = "red", lwd = 2)
      grid(col = "grey60")
}

