#*******************************************************************
# Probabilit binomiale de l'IF asymptotique Gaussien de seconde
# en fonction de n, p +- 1/racine(n)
pIFasy1_1 <- function(n = 200, ppop= .5, proba = .95){
   P <- function(n, ppop, proba){
        binf <- max(floor(n * ppop - sqrt(n)), 0)
        bsup <- min(floor(n * ppop + sqrt(n)), n)
        sum(dbinom((binf + 1):bsup, n, ppop))
   }
   y <- NULL
   for(i in 1:n) y[i] <- P(i, ppop, proba)
   #-----Affichage des graphiques-----
   plot(1:n, y, pch = 19, cex = .5, ylim = c(.9, 1),
         col = c("red", "green")[(1:n)%%2 + 1],
         xlab = "Taille n de l'chantillon",
         ylab = "Probabilit binomiale d'tre dans l'IF asymptotique",
         main = paste("Exploration de l'intervalle de fluctuation : influence de n",
                      "avec ppop =",ppop))
      abline(h = proba, col = "blue")
}
