#*******************************************************************
# Probabilit binomiale de l'IF asymptotique Gaussien de terminale
# en fonction de n, (p +- 1,96*racine(p(1-p)/n))
pIFasy2_1 <- function(n = 200, ppop= .5, proba = .95){
   P <- function(n, ppop, proba){
      g <- qnorm(1 - (1 - proba) / 2)
      binf <- max(floor(n * ppop - g * sqrt(ppop * (1 - ppop) * n)), 0)
      bsup <- min(floor(n * ppop + g * sqrt(ppop * (1 - ppop) * n)), n)
      sum(dbinom((binf + 1):bsup, n, ppop))
   }
   y <- vector(length = n)
   for(i in 1:n) {y[i] <- P(i, ppop, proba)}
   #-----Affichage des graphiques-----
   plot(1:n, y, pch = 19, cex = .5, ylim = c(.9, 1),
         col = c("red", "green")[(1:n)%%2 + 1],
         xlab = "Taille n de l'chantillon",
         ylab = "Probabilit binomiale d'tre dans l'IF asymptotique",
         main = paste("Exploration de l'intervalle de fluctuation :",
                      " influence de n avec ppop =", ppop))
      abline(h = proba, col = "blue")
}
